<?php

namespace Fazed\NyaaRssParser;

use Fazed\NyaaRssParser\Contracts\NyaaRssParserContract;
use Fazed\NyaaRssParser\Contracts\HttpClient\ClientContract as HttpClientContract;

class NyaaRssParser implements NyaaRssParserContract
{
    /**
     * @var HttpClientContract
     */
    private $httpClient;

    /**
     * NyaaRssParser constructor.
     *
     * @param HttpClientContract $httpClient
     */
    public function __construct(HttpClientContract $httpClient)
    {
        $this->httpClient = $httpClient;
    }

    /**
     * {@inheritdoc}
     */
    public function getRssFeed($category = null, $filter = null, array $additionalParameters = [])
    {
        return $this->httpClient->dispatchRequest(
            array_merge(['c' => $category, 'f' => $filter], $additionalParameters)
        );
    }
}
